import Component from '@glimmer/component';
import { TypedBufferedChangeset } from '../components/typed-changeset';
export interface BaseFormArgs<T extends Record<string, any> = Record<string, any>> {
    changeset: TypedBufferedChangeset<T>;
    saveFunction: (changeset: TypedBufferedChangeset<T>, ...otherArgs: unknown[]) => Promise<void>;
}
export default abstract class BaseForm<T extends BaseFormArgs<K>, K extends Record<string, any> = Record<string, any>> extends Component<T> {
    constructor(owner: unknown, args: T);
    rollback(e?: Event): void;
    submit(e?: Event, ...otherArgs: unknown[]): Promise<void>;
}
